close all; clear all; clc;
%% SER
maxNumErrs=2000;
maxNumBits=10^6;
EsNoVec=-6:2:30;
for n=1:length(EsNoVec)
    EsNo=EsNoVec(n);
    sim('TP05')
    SER_Vec(n,:)=SERQAM
end
M=256; k=8;
EsN1=10.^(EsNoVec/10);
Ps=1-(1-2*(1-1/sqrt(M))*Q(sqrt(3*EsN1/(M-1)))).^2;
figure (1)
semilogy(EsNoVec,SER_Vec(:,1),'--bo');
hold on 
semilogy(EsNoVec,Ps,'r.-');
xlabel('Es/N en db');
ylabel('SER');
title('SER de QAM');
%% BER
k=8;
EbN0=EsN0Vec+10*log(k);
Pb=Ps/k;
BER_Vec=SER_Vec(:,1)/k;
figure(2)
semilogy(EbN0, BER_Vec, 'bo--')
xlabel('Eb/N0(db)');
ylabel('BER');
title('BER pour la modulation QPSK');
hold on
semilogy(EbN0,Pb,'r.-')
